package org.switchyard.quickstarts.bpm.service;

import java.util.HashMap;
import java.util.Map;

import javax.inject.Inject;

import org.switchyard.component.bean.Reference;
import org.switchyard.component.bean.Service;
import org.switchyard.quickstarts.bean.service.OrderService;
import org.switchyard.quickstarts.bpm.service.data.Order;

@Service(Inventory.class)
public class InventoryBean implements
		org.switchyard.quickstarts.bpm.service.Inventory {

	private final Map<String, Integer> inventory = new HashMap<String, Integer>();

	@Inject
	@Reference
	private OrderService orderService;

	public InventoryBean() {
		inventory.put("cowbell", 100);
	}

	@Override
	public boolean checkAvailability(Order order) {
		if (orderService != null) {
			org.switchyard.quickstarts.bean.service.Order newOrder = new org.switchyard.quickstarts.bean.service.Order();
			newOrder.setItemId(order.getItemId());
			newOrder.setOrderId(order.getOrderId());
			newOrder.setQuantity(order.getQuantity());

			orderService.submitOrder(newOrder);
		}

		return inventory.containsKey(order.getItemId().toLowerCase())
				&& inventory.get(order.getItemId().toLowerCase()) >= order
						.getQuantity();
	}

}
